Bug 170116 - aio_sigevent in aio control block is ignored if request is posted using lio_listio()
aio_sigevent in aio control block is ignored if request is posted using lio_l...
Product: Fedora
Classification: Fedora
Component: glibc (Show other bugs)
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Jakub Jelinek
Brian Brock
Depends On:
  Show dependency treegraph
Reported: 2005-10-07 10:32 EDT by Elena Vengerova
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version: 2.3.90-26
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-01-04 07:41:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Elena Vengerova 2005-10-07 10:32:23 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.8) Gecko/20050513 Fedora/1.7.8-2

Description of problem:
In fact, I'm not sure that it is a bug. From lio_listio man it is not clear if it is allowed to specify different notification for separate requests posted using lio_listio or not.

From the one hand it is specified that ""If sig is NULL, then no  asynchronous  notification  shall  occur."

From the other hand in the description of EINTR error description it is stated that "Note  that,  since  each  I/O  operation invoked  by lio_listio()  may  possibly  provoke a signal when it completes ...". How the request may provoke the signal is it's not allowed to specify the separate notification for it?

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. Create the socket, connect it.
2. Construct aio control block with SIGEV_SIGNAL or SIGEV_THREAD notification.
3. Post the aio request using aio_read - the completion notification is received.
4. Post the aio request using lio_listio(LIO_NOWAIT) - no completion notification is received.

Expected Results:  IMHO all per-request notifications (if specified) and notification specified in sig parameter of lio_listio() should be delivered.

Additional info:
Comment 3 Jakub Jelinek 2006-01-04 07:41:52 EST
Should be fixed in glibc-2.3.90-26 in rawhide.

Note You need to log in before you can comment on or make changes to this bug.